diff --git a/ospfd/ospf_spf.c b/ospfd/ospf_spf.c
index 274d5bc9af7b..e47ebaf1e12f 100644
--- a/ospfd/ospf_spf.c
+++ b/ospfd/ospf_spf.c
@@ -57,8 +57,6 @@ static void ospf_spf_set_reason(ospf_spf_reason_t reason)
 	spf_reason_flags |= 1 << reason;
 }
 
-static void ospf_vertex_free(void *);
-
 /*
  * Heap related functions, for the managment of the candidates, to
  * be used with pqueue.
@@ -207,7 +205,7 @@ static struct vertex *ospf_vertex_new(struct ospf_area *area,
 	return new;
 }
 
-static void ospf_vertex_free(void *data)
+void ospf_vertex_free(void *data)
 {
 	struct vertex *v = data;
 
diff --git a/ospfd/ospf_spf.h b/ospfd/ospf_spf.h
index 0837748d0b14..3603e71c5b07 100644
--- a/ospfd/ospf_spf.h
+++ b/ospfd/ospf_spf.h
@@ -73,6 +73,7 @@ extern void ospf_spf_calculate_areas(struct ospf *ospf,
 				     struct route_table *all_rtrs,
 				     struct route_table *new_rtrs);
 extern void ospf_rtrs_free(struct route_table *);
+extern void ospf_vertex_free(void *data);
 extern void ospf_spf_cleanup(struct vertex *spf, struct list *vertex_list);
 extern void ospf_spf_copy(struct vertex *vertex, struct list *vertex_list);
 extern void ospf_spf_remove_resource(struct vertex *vertex,
diff --git a/ospfd/ospf_ti_lfa.c b/ospfd/ospf_ti_lfa.c
index d8a2613075ee..927a831f426a 100644
--- a/ospfd/ospf_ti_lfa.c
+++ b/ospfd/ospf_ti_lfa.c
@@ -782,6 +782,7 @@ ospf_ti_lfa_generate_p_space(struct ospf_area *area, struct vertex *child,
 
 	p_space = XCALLOC(MTYPE_OSPF_P_SPACE, sizeof(struct p_space));
 	vertex_list = list_new();
+	vertex_list->del = ospf_vertex_free;
 
 	/* The P-space will get its own SPF tree, so copy the old one */
 	ospf_spf_copy(area->spf, vertex_list);
